divert(-1)
define(`el_titulo', `Flex')dnl
define(`m4_prev',1)dnl
define(`m4_next',3)dnl
include(`cabe.m4')dnl
<!-- $Id: 1.m4,v 1.1 1998/10/31 17:41:00 luis Exp $ -->
m4_h1(Flex: generador de analizadores lxicos)

m4_h2(Introduccin)

<p>m4_color(red, Flex) es, segn su definicin una herramienta para
ayudar al programador a generar un analizador lxico, palabra un tanto
compleja que aleja a muchos de su compaa.

<p>Sin embargo, flex es una potente herramienta para el programador, ya
que permite la generacin de rutinas, cuya escritura manual requiere pasar
largo tiempo escribiendo, y largo tiempo depurando.

<p>Veamos un ejemplo:

<p>Supongamos que queremos construir una rutina, que lea los caracteres
devueltos por una lnea RS-232 a la que tenemos enchufado un modem, pero que
filtre los cdigos devueltos por el modem (por ejemplo m4_color(blue, CONNECT)
o m4_color(blue, NO CARRIER)) entregando cdigos especiales para estos casos.

<p>La solucin clara, sera tener una rutina que devuelva cdigos enteros,
reservando los 256 primeros cdigos para cualquier posible caracter vlido y
del 257 en adelante, para los cdigos de error entregados por el modem.

<p>Lo primero que nos viene a la mente es que el diseo de un m4_color(red,
autmata reconocedor de cadenas)m4_notapie(`As se llama a los artefactos
matemticos que, basndose en una tabla, un conjunto de estados finito, y
un alfabeto de caracteres entrantes, permiten el reconocimiento de frases
de lenguajes definidos por medio de m4_color(red, expresiones
regulares) (ver m4_tt(regcomp(3)), m4_tt(regexec(3)), etc.)') de un modo
eficiente (que de una sola pasada por el texto, que tenga un nmero de
estados mnimo, que ocupe poca memoria, que est libre de errores, etc.)
m4_notapie(`El requisito de que est libre de errores es, a veces, un requisito
muy dificil de resolver, llegando a arruinar un proyecto, si no se dispone
de la herramienta adecuada.') es muy dificil de conseguir, pero muy facil
si se sabe un poco de m4_color(red, expresiones regulares)m4_notapie(`Las
expresiones regulares constituyen un lenguaje o lgebra de definicin de
lenguajes a partir de una serie de operaciones con cadenas de caracteres,
tales como la concatenacin de cadenas, la repeticin, el empleo de comodines,
y la inclusin opcional de subcadenas, que permiten la definicin de
lenguajes formales de una cierta complejidad')

<p>En el caso de las respuestas de un modem, tendremos las siguientes cadenas,
que sern tratadas especialmente (y de una sola pasada) por el autmata
generado por m4_color(red, m4_tt(flex(1))):

<UL>
  <li>Las cadenas m4_color(blue,OK\n), m4_color(blue, ERROR\n), m4_color(blue,
    BUSY\n).  Las expresiones regulares que definen estas cadenas de caracteres
	son sencillas, se forman con la concatenacin de los caracteres individuales
	que las forman.
  <li>Cadenas mas complejas en su forma, que permitan repeticiones o la
    aparicin opcional de subcadenas.  Ejemplos son m4_color(blue,
	CONNECT xxx\n) o m4_color(blue, NO CARRIER\n).
</ul>

<p>El programa siguiente nos mostrar el cdigo de una rutina, que leyendo de
la entrada estandar, permite reconocer las cadenas anteriores y devolver
cdigos especiales, cuando estas cadenas se presenten a la entrada.

m4_code(flex.l.1)

<p>Cuando ejecutemos flex sobre este cdigo, se generar un fichero fuente C
con una rutina, llamada m4_color(red, m4_tt(yylex())), que leer la entrada
estandar, y retornar cdigos enteros con los valores de los caracteres
introducidos, o los cdigos descritos en el programa, para los casos de
reconocimiento de las cadenas devueltas por el modem.  Bsicamente, la rutina
m4_color(red, m4_tt(yylex())) tiene una tabla de doble entrada (estado
actual, caracter leido) en la que encontramos el siguiente estado, y la
ejecucin del cdigo C intercalado en las llaves, que  se ejecuta cuando
se reconoce una de las cadenas programadas.

<p>Ventajas:

<UL>
  <li>El tiempo de desarrollo es bastante mas corto.  La especificacin de
    expresiones regulares es mucho mas prxima al problema, y mas facil de
	generar, que la informacin relativa al autmata que reconocer las
	cadenas de caracteres.  El nmero de estados, as como el tamao de la
	tabla, crece rpidamente con el nmero y complejidad de las cadenas,
	llegando un momento que el problema se hace intratable por otros medios.
  <li>El nmero de errores es menor, al limitarse a la codificacin realizada
    por nosotros, o a las definiciones de las expresiones regulares`'m4_notapie(`
	En este punto, conviene hacer incapi en que la especificacin del programa,
	tal y como se da en el ejemplo no es del todo correcta, ya que aceptara
	como vlida la cadena m4_color(blue, NOCARRIER\n), ya que contiene una
	cadena de cero espacios entre las palabras m4_color(blue, NO) y
	m4_color(blue, CARRIER).  Una expresin mas apropiada hubiera sido:
<PRE>

NO\ +CARRIER\n

</pre>
	donde se aceptan uno o mas espacios en blanco.')
</UL>

<p>Inconvenientes:

<UL>
  <li>A veces, cuando la entrada no es precsamente m4_color(blue,m4_tt(stdin))
    o cuando debemos analizar datos interactivos (como la entrada en modo
	raw del terminal, por ejemplo en un programa <i>calculadora</i>) la
	adaptacin del fuente flex, para que la entrada se haga sin buffer, o para
	poder cambiar el fichero de entrada se hace un tanto oscura o compleja.
  <li>Bueno, es algo mas que hay que aprender m4_tt(:-`)').
</ul>



<!-- $Id: 1.m4,v 1.1 1998/10/31 17:41:00 luis Exp $ -->
